## pplacer 1.1~alpha19

=== Makefile ===
RELEASE=pplacer guppy rppr
DEBUG=pplacer.d guppy.d rppr.d
DESCRIPT:=pplacer-$(shell uname)-$(shell git describe --tags)

all: $(RELEASE)
debug: $(DEBUG)

# For OPAM
OCAML_TOPLEVEL_PATH = $$OCAML_TOPLEVEL_PATH
ifneq ($(OCAML_TOPLEVEL_PATH),)
	TOPLEVEL_FLAGS=-I ${OCAML_TOPLEVEL_PATH}
endif

$(RELEASE):
	if [ ! -e bin ]; then mkdir bin; fi
	make $@.native
	cp `readlink $@.native` bin/$@
	rm $@.native

%.native %.byte %.p.native:
	ocamlbuild $@

clean:
	rm -rf bin
	rm -f tests.native
	ocamlbuild -clean
	rm -f *.mltop

%.d: %.d.byte
	if [ ! -e bin ]; then mkdir bin; fi
	cp "$<" "bin/$@"

%.top: %.byte
	find _build -name '*.cmo' -print0 | xargs -0I% basename % .cmo > $*.mltop
	ocamlbuild $@
	rm $*.mltop

test: tests.native
	./tests.native

%.runtop: %.top
	rlwrap ./$*.top `find _build -name "*.cmi" | xargs -n1 dirname | sort -u | sed -e 's/^/-I /'` $(TOPLEVEL_FLAGS)

runcaml:
	rlwrap ocaml

tags:
	otags `find . -name "*.ml" | grep -v "_build"`

docs: gen_docs.native
	./gen_docs.native
	make -C docs html
	touch docs/_build/html/.nojekyll

pplacer-linux.zip: $(RELEASE)
	rm -rf $(DESCRIPT)
	mkdir $(DESCRIPT)
	cp -r bin/* scripts $(DESCRIPT)
	zip -r pplacer-linux.zip $(DESCRIPT)/*
	rm -rf $(DESCRIPT)

zip: pplacer-linux.zip

.latest-upload: pplacer-linux.zip
	curl --upload-file ./pplacer-linux.zip https://transfer.sh/$(DESCRIPT).zip > .latest-upload

upload: .latest-upload
	curl -X POST --data-urlencode 'payload={"text": "Latest pplacer uploaded to '$(shell cat .latest-upload)'"}' $(SLACK_URL)


.PHONY: $(RELEASE) clean runcaml tags test docs zip upload

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/pplacer.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/pplacer.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/pplacer"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/pplacer"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== pam_src/Makefile ===
CFLAGS = -Wall -pedantic -std=c99 -DPAM_TEST
LDLIBS = -lgsl -lgslcblas

debug: CFLAGS += -g -O0
debug: pam

release: CFLAGS += -O3
release: pam

clean:
	rm -f *.o pam

.PHONY: debug release clean

=== debian/changelog ===
pplacer (1.1~alpha19-4) unstable; urgency=medium

  * Team Upload.
  * Pull and modify upstream PR to fix FTBFS w/ new
    version of libocamlgsl-ocaml-dev (Closes: #975858)
  * Standards version: 4.5.1

 -- Nilesh Patra <npatra974@gmail.com>  Tue, 01 Dec 2020 19:54:07 +0530

pplacer (1.1~alpha19-3) unstable; urgency=medium

  * Include /usr/share/ocaml/ocamlvars.mk
    Closes: #968474
  * Adapt to new version of ocaml-batteries

 -- Andreas Tille <tille@debian.org>  Sun, 16 Aug 2020 16:59:18 +0200

pplacer (1.1~alpha19-2) unstable; urgency=medium

  [ Shayan Doust ]
  * Add myself as an uploader

  [ Andreas Tille ]
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

 -- Andreas Tille <tille@debian.org>  Tue, 14 Jul 2020 23:30:13 +0200

pplacer (1.1~alpha19-1) unstable; urgency=medium

  * Initial release (Closes: #963476)

 -- Andreas Tille <tille@debian.org>  Mon, 22 Jun 2020 09:22:18 +0200

=== debian/control ===
Source: pplacer
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Shayan Doust <hello@shayandoust.me>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-ocaml,
               ocaml-nox,
               ocamlbuild,
               libcsv-ocaml-dev,
               libxmlm-ocaml-dev,
               libbatteries-ocaml-dev,
               libmcl-ocaml-dev,
               libocamlgsl-ocaml-dev,
               libsqlite3-ocaml-dev,
               libzip-ocaml-dev,
               mcl,
               libounit-ocaml-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/pplacer
Vcs-Git: https://salsa.debian.org/med-team/pplacer.git
Homepage: https://github.com/matsen/pplacer
Rules-Requires-Root: no

Package: pplacer
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: phylogenetic placement and downstream analysis
 Pplacer places reads on a phylogenetic tree. guppy (Grand Unified
 Phylogenetic Placement Yanalyzer) yanalyzes them. rppr is a helpful tool
 for working with reference packages.
 .
 Pplacer places query sequences on a fixed reference phylogenetic tree to
 maximize phylogenetic likelihood or posterior probability according to a
 reference alignment. Pplacer is designed to be fast, to give useful
 information about uncertainty, and to offer advanced visualization and
 downstream analysis.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

# for hardening you might like to uncomment this:
# export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with=ocaml

override_dh_auto_build:
	# Fix race condition (fails due to multiple mkdirs)
	dh_auto_build --no-parallel

### When overriding auto_test make sure DEB_BUILD_OPTIONS will be respected
#override_dh_auto_test:
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	do_stuff_for_testing
#endif

=== debian/watch ===
version=4

opts="uversionmangle=s/([\d.]+).((beta|alpha))(\d*)(.*)$/$1~$2$4/" \
  https://github.com/matsen/pplacer/releases .*/archive/v?@ANY_VERSION@\.tar\.gz
